Leetcode第一题<two sum>

从今天开始刷题啦。

题目原文

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:
Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

这道题一共有三种解法:

第一种算法很容易想的到:暴力破解
public class Solution {
int[] nums;
int target;
public int[] twoSum(int[] nums, int target) {
    int i,j;
    int[] index=new int[]{0,1};
    for(i=0;i<nums.length;i++){
        for(j=i+1;j<nums.length;j++){
            if ((nums[i]+nums[j])== target)
                    return (new int[]{i,j});
        }
    }
    return index;
}}

这种算法不多解释。主要说明的是算法时间复杂度O(n^2),空间复杂度O(1)

第二种算法使用到了HashSet

这种算法利用的是HashSet元素不能重复。

第三种算法则使用了HashMap

第三种和第二种原理相同,不过辅助空间要翻倍。

public class Solution2 {
    int[] nums;
    int target;
    public int[] twoSum(int[] nums, int target) {
    HashMap<Integer,Integer> map=new HashMap<Integer,Integer>();
    int[] result=new int[]{0,1};
    int i=0;
    int index;
    for(i=0;i<nums.length;i++)
    {
    if (map.containsKey(nums[i]))
    {
    index=map.get(nums[i]);
    result[0]=index;
    result[1]=i;
    break;
    }
    else{
    map.put(target-nums[i],i);
    }
    }
        return result;
    }
    }

这种算法时间复杂度为O(n),空间复杂度为O(n)

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值